//
//  _MiscMergeIdentifyCommand.m
//            Written by Don Yacktman and Carl Lindberg
//        Copyright 2002 by Don Yacktman and Carl Lindberg.
//                     All rights reserved.
//      This notice may not be removed from this source code.
//
//	This header is included in the MiscKit by permission from the author
//	and its use is governed by the MiscKit license, found in the file
//	"License.rtf" in the MiscKit distribution.  Please refer to that file
//	for a list of all applicable permissions and restrictions.
//

#import "_MiscMergeIdentifyCommand.h"
#import "MiscMergeExpression.h"
#import <MiscFoundation.subproj/NSString+MiscAdditions.h>

@implementation _MiscMergeIdentifyCommand

- (void)dealloc
{
    [field1 release];
    [expression release];
    [super dealloc];
}

- (BOOL)parseFromScanner:(NSScanner *)aScanner template:(MiscMergeTemplate *)template;
{
    [self eatKeyWord:@"identify" fromScanner:aScanner isOptional:NO];

    field1 = [self getArgumentStringFromScanner:aScanner toEnd:NO];
    field1 = [[field1 stringByTrimmingWhitespace] retain];

    if ( ![self eatKeyWord:@"=" fromScanner:aScanner isOptional:YES] )
        [self error_conditional:@"Identify requires operator to be an =."];

    expression = [[self getExpressionFromScanner:aScanner] retain];

    return YES;
}

- (MiscMergeCommandExitType)executeForMerge:(MiscMergeEngine *)aMerger
{
    [aMerger setLocalValue:[expression evaluateWithEngine:aMerger] forKey:field1];
    return MiscMergeCommandExitNormal;
}

@end
